@online{OffscreenCanvas,
  author = {Mozilla Web Documentation},
  title = {OffscreenCanvas},
  year = 2019,
  url = {https://developer.mozilla.org/en-US/docs/Web/API/OffscreenCanvas},
  note = "[Accessed 2020-02-10]"
}

@online{puppeteer,
  author = {Chrome DevTools Team},
  title = {puppeteer - Headless Chrome Node.js API},
  year = 2020,
  url = {https://github.com/puppeteer/puppeteer},
  note = "[Accessed 2020-02-10]"
}

@online{puppeteerDocs,
  author = {Chrome DevTools Team},
  title = {Puppeteer API Tip-Of-Tree},
  year = 2020,
  url = {https://github.com/puppeteer/puppeteer/blob/master/docs/api.md},
  note = "[Accessed 2020-02-10]"
}

@online{ScratchWikiThreePointZero,
  author = {The MIT Scratch Team},
  title = {Scratch 3.0},
  year = 2020,
  url = {https://en.scratch-wiki.info/wiki/Scratch_3.0},
  note = "[Accessed 2020-04-03]"
}

@online{ScratchWikiWait,
  author = {The MIT Scratch Team},
  title = {Wait () Secs (block)},
  year = 2019,
  url = {https://en.scratch-wiki.info/wiki/Wait_()_Secs_(block)},
  note = "[Accessed 2020-03-07]"
}

@online{ScratchWikiSay,
  author = {The MIT Scratch Team},
  title = {Say () for () Secs (block)},
  year = 2019,
  url = {https://en.scratch-wiki.info/wiki/Say_()_for_()_Secs_(block)},
  note = "[Accessed 2020-03-07]"
}

@online{ScratchWikiThink,
  author = {The MIT Scratch Team},
  title = {Think () for () Secs (block)},
  year = 2019,
  url = {https://en.scratch-wiki.info/wiki/Think_()_for_()_Secs_(block)},
  note = "[Accessed 2020-03-07]"
}

@online{ScratchWikiProjectTimer,
  author = {The MIT Scratch Team},
  title = {Timer (block)},
  year = 2019,
  url = {https://en.scratch-wiki.info/wiki/Timer_(block)},
  note = "[Accessed 2020-04-03]"
}

@online{ScratchWikiProjectGlideSecsToXY,
  author = {The MIT Scratch Team},
  title = {Glide () Secs to X: () Y: () (block)},
  year = 2019,
  url = {https://en.scratch-wiki.info/wiki/Glide_()_Secs_to_X:_()_Y:_()_(block)},
  note = "[Accessed 2020-04-03]"
}

@online{ScratchWikiProjectGlideTo,
  author = {The MIT Scratch Team},
  title = {Glide () Secs to () (block)},
  year = 2019,
  url = {https://en.scratch-wiki.info/wiki/Glide_()_Secs_to_()_(block)},
  note = "[Accessed 2020-04-03]"
}

@online{ScratchSource,
  author = {The MIT Scratch Team},
  title = {Scratch Github Repositories},
  year = 2020,
  url = {https://github.com/LLK},
  note = "[Accessed 2020-03-07]"
}

@online{ScratchSourceWait,
  author = {The MIT Scratch Team},
  title = {wait (args, util) function source code},
  year = 2020,
  url = {https://github.com/LLK/scratch-vm/blob/59a865ef470d726837253d21055e481f65f6dc1c/src/blocks/scratch3_control.js#L110},
  note = "[Accessed 2020-03-07]"
}

@online{ScratchSourceThink,
  author = {The MIT Scratch Team},
  title = {thinkforsecs (args, util) function source code},
  year = 2019,
  url = {https://github.com/LLK/scratch-vm/blob/92c1711937c5b9eb1bd8e8937f87ec3f0943e465/src/blocks/scratch3_looks.js#L311},
  note = "[Accessed 2020-03-07]"
}

@online{ScratchSourceSay,
  author = {The MIT Scratch Team},
  title = {sayforsecs (args, util) function source code},
  year = 2019,
  url = {https://github.com/LLK/scratch-vm/blob/92c1711937c5b9eb1bd8e8937f87ec3f0943e465/src/blocks/scratch3_looks.js#L331},
  note = "[Accessed 2020-03-07]"
}

@online{ScratchSourceGlideSecsToXY,
  author = {The MIT Scratch Team},
  title = {glide (args, util) function source code},
  year = 2019,
  url = {https://github.com/LLK/scratch-vm/blob/19a4329c8bf24c4fecfc5aafb0cec8684d9b6dd0/src/blocks/scratch3_motion.js#L144},
  note = "[Accessed 2020-03-07]"
}

@online{ScratchSourceProjectGlideTo,
  author = {The MIT Scratch Team},
  title = {glideTo (args, util) function source code},
  year = 2019,
  url = {https://github.com/LLK/scratch-vm/blob/19a4329c8bf24c4fecfc5aafb0cec8684d9b6dd0/src/blocks/scratch3_motion.js#L179},
  note = "[Accessed 2020-04-03]"
}

@online{ScratchSourceProjectTimer,
  author = {The MIT Scratch Team},
  title = {projectTimer () function source code},
  year = 2019,
  url = {https://github.com/LLK/scratch-vm/blob/445ee4698463e4a23ac1913c05caa2953ae291c8/src/io/clock.js#L16},
  note = "[Accessed 2020-04-03]"
}

@online{ScratchSourceUtilTimer,
  author = {The MIT Scratch Team},
  title = {class Timer source code},
  year = 2019,
  url = {https://github.com/LLK/scratch-vm/blob/develop/src/util/timer.js#L3},
  note = "[Accessed 2020-04-03]"
}

@online{ScratchSourceExecute,
  author = {The MIT Scratch Team},
  title = {execute () source source code},
  year = 2019,
  url = {https://github.com/LLK/scratch-vm/blob/develop/src/engine/execute.js#L506},
  note = "[Accessed 2020-04-03]"
}

@online{ScratchSourceCentralDispatch,
  author = {The MIT Scratch Team},
  title = {class CentralDispatch},
  year = 2019,
  url = {https://github.com/LLK/scratch-vm/blob/e89f5d0361305bab466887ec309dc0261fffad58/src/dispatch/central-dispatch.js#L12},
  note = "[Accessed 2020-04-05]"
}

@online{ScratchHomePage,
  author = {The MIT Scratch Team},
  title = {Scratch Project Homepage},
  year = 2020,
  url = {https://scratch.mit.edu/},
  note = "[Accessed 2020-04-03]"
}

@online{LifelongKindergarten,
  author = {Lifelong Kindergarten},
  title = {Lifelong Kindergarten Homepage},
  year = 2020,
  url = {https://www.media.mit.edu/groups/lifelong-kindergarten/overview/},
  note = "[Accessed 2020-05-25]"
}

@online{ScratchHomePageFAQ,
  author = {The MIT Scratch Team},
  title = {Scratch Project FAQ},
  year = 2020,
  url = {https://scratch.mit.edu/info/faq},
  note = "[Accessed 2020-04-03]"
}

@online{WhiskerSource,
  author = {Chair of Software Engineering II, Uni Passau},
  title = {Whisker Github Repositories},
  year = 2020,
  url = {https://github.com/se2p},
  note = "[Accessed 2020-04-04]"
}

@online{WhiskerSourceStep,
  author = {Chair of Software Engineering II, Uni Passau},
  title = {step (callback)},
  year = 2019,
  url = {https://github.com/se2p/whisker-main/blob/ec7266710720fc5cfbcc212872fdfbad247a64f8/src/vm/stepper.js#L92},
  note = "[Accessed 2020-04-05]"
}

@online{WhiskerSourceSetup,
  author = {Chair of Software Engineering II, Uni Passau},
  title = {async setup (project)},
  year = 2019,
  url = {https://github.com/se2p/whisker-main/blob/a98927f281003fcbb57ef7d4dc5b4a8a4effac6a/src/vm/vm-wrapper.js#L247},
  note = "[Accessed 2020-04-05]"
}

@online{WhiskerSourceVMWrapper,
  author = {Chair of Software Engineering II, Uni Passau},
  title = {class VMWrapper},
  year = 2019,
  url = {https://github.com/se2p/whisker-main/blob/a98927f281003fcbb57ef7d4dc5b4a8a4effac6a/src/vm/vm-wrapper.js#L10},
  note = "[Accessed 2020-04-05]"
}

@online{TestAnything,
  author = {TestAnything},
  title = {TAP13 - The Test Anything Protocol v13},
  year = 2020,
  url = {https://testanything.org/tap-version-13-specification.html},
  note = "[Accessed 2020-04-04]"
}

@online{ScratchWikiSingleStepping,
  author = {The MIT Scratch Team},
  title = {Single Stepping},
  year = 2020,
  url = {https://en.scratch-wiki.info/wiki/Single_Stepping},
  note = "[Accessed 2020-04-10]"
}

@online{ScratchWikiTurboMode,
  author = {The MIT Scratch Team},
  title = {Turbo Mode (3.0)},
  year = 2020,
  url = {https://en.scratch-wiki.info/wiki/Turbo_Mode_(3.0)},
  note = "[Accessed 2020-04-10]"
}

@online{KarmaSharding,
  author = {Joel Jeske},
  title = {Karma Sharding - A Karma JS Framework to support sharding tests to run in parallel across multiple browsers},
  year = 2020,
  url = {https://github.com/rschuft/karma-sharding},
  note = "[Accessed 2020-04-20]"
}

@online{KarmaParallel,
  author = {Ryan Schuft},
  title = {Karma Parallel - Karma plugin to allow tests to be distributed across multiple browsers},
  year = 2020,
  url = {https://github.com/joeljeske/karma-parallel},
  note = "[Accessed 2020-04-20]"
}

@online{Karma,
  author = {Karma},
  title = {Karma - Spectacular Test Runner for JavaScript},
  year = 2020,
  url = {https://github.com/joeljeske/karma-parallel},
  note = "[Accessed 2020-04-20]"
}

@inproceedings{Johnson16,
  author = {Johnson, David E.},
  title = {ITCH: Individual Testing of Computer Homework for Scratch Assignments},
  year = {2016},
  isbn = {9781450336857},
  publisher = {Association for Computing Machinery},
  address = {New York, NY, USA},
  url = {https://doi.org/10.1145/2839509.2844600},
  doi = {10.1145/2839509.2844600},
  booktitle = {Proceedings of the 47th ACM Technical Symposium on Computing Science Education},
  pages = {223–227},
  numpages = {5},
  keywords = {run-time analysis, computer science education, automated testing, scratch},
  location = {Memphis, Tennessee, USA},
  series = {SIGCSE ’16},
  note = "[Accessed 2020-04-21]"
}

@inproceedings{Parsa16,
  author    = {Masoumeh Parsa and
               Adnan Ashraf and
               Dragos Truscan and
               Ivan Porres},
  editor    = {Wolf Zimmermann and
               Lukas Alperowitz and
               Bernd Br{\"{u}}gge and
               J{\"{o}}rn Fahsel and
               Andrea Herrmann and
               Anne Hoffmann and
               Andreas Krall and
               Dieter Landes and
               Horst Lichter and
               Dirk Riehle and
               Ina Schaefer and
               Constantin Scheuermann and
               Alexander Schlaefer and
               Sibylle Schupp and
               Andreas Seitz and
               Andreas Steffens and
               Andr{\'{e}} Stollenwerk and
               R{\"{u}}diger Wei{\ss}bach},
  title     = {On Optimization of Test Parallelization with Constraints},
  booktitle = {Gemeinsamer Tagungsband der Workshops der Tagung Software Engineering
               2016 {(SE} 2016), Wien, 23.-26. Februar 2016},
  series    = {{CEUR} Workshop Proceedings},
  volume    = {1559},
  pages     = {164--171},
  publisher = {CEUR-WS.org},
  year      = {2016},
  url       = {http://ceur-ws.org/Vol-1559/paper21.pdf},
  timestamp = {Sun, 09 Jun 2019 18:41:14 +0200},
  biburl    = {https://dblp.org/rec/conf/se/ParsaATP16.bib},
  bibsource = {dblp computer science bibliography, https://dblp.org},
  note = "[Accessed 2020-04-21]"
}

@article{Elbaum00,
  author = {Elbaum, Sebastian and Malishevsky, Alexey G. and Rothermel, Gregg},
  title = {Prioritizing Test Cases for Regression Testing},
  year = {2000},
  issue_date = {September 2000},
  publisher = {Association for Computing Machinery},
  address = {New York, NY, USA},
  volume = {25},
  number = {5},
  issn = {0163-5948},
  url = {https://doi.org/10.1145/347636.348910},
  doi = {10.1145/347636.348910},
  journal = {SIGSOFT Softw. Eng. Notes},
  month = aug,
  pages = {102–112},
  numpages = {11},
  note = "[Accessed 2020-04-21]"
}

@inproceedings{Saff05,
  author = {Saff, David and Artzi, Shay and Perkins, Jeff H. and Ernst, Michael D.},
  title = {Automatic Test Factoring for Java},
  year = {2005},
  isbn = {1581139934},
  publisher = {Association for Computing Machinery},
  address = {New York, NY, USA},
  url = {https://doi.org/10.1145/1101908.1101927},
  doi = {10.1145/1101908.1101927},
  booktitle = {Proceedings of the 20th IEEE/ACM International Conference on Automated Software Engineering},
  pages = {114–123},
  numpages = {10},
  keywords = {unit testing, test factoring, mock objects},
  location = {Long Beach, CA, USA},
  series = {ASE ’05},
  note = "[Accessed 2020-04-21]"
}

@inproceedings{Bach17,
  author    = {Thomas Bach and
               Artur Andrzejak and
               Ralf Pannemans},
  title     = {Coverage-Based Reduction of Test Execution Time: Lessons from a Very
               Large Industrial Project},
  booktitle = {2017 {IEEE} International Conference on Software Testing, Verification
               and Validation Workshops, {ICST} Workshops 2017, Tokyo, Japan, March
               13-17, 2017},
  pages     = {3--12},
  publisher = {{IEEE} Computer Society},
  year      = {2017},
  url       = {https://doi.org/10.1109/ICSTW.2017.6},
  doi       = {10.1109/ICSTW.2017.6},
  timestamp = {Mon, 24 Feb 2020 17:17:02 +0100},
  biburl    = {https://dblp.org/rec/conf/icst/BachAP17.bib},
  bibsource = {dblp computer science bibliography, https://dblp.org},
  note = "[Accessed 2020-04-21]"
}

@article{Alves19,
  author    = {Nathalia da Cruz Alves and
               Christiane Gresse von Wangenheim and
               Jean C. R. Hauck},
  title     = {Approaches to Assess Computational Thinking Competences Based on Code
               Analysis in {K-12} Education: {A} Systematic Mapping Study},
  journal   = {Informatics in Education},
  volume    = {18},
  number    = {1},
  pages     = {17--39},
  year      = {2019},
  url       = {https://www.mii.lt/informatics\_in\_education/htm/infedu.2019.02.htm},
  timestamp = {Fri, 28 Jun 2019 11:14:00 +0200},
  biburl    = {https://dblp.org/rec/journals/iie/AlvesWH19.bib},
  bibsource = {dblp computer science bibliography, https://dblp.org},
  note = "[Accessed 2020-04-21]"
}

@inproceedings{StahlbauerKF19,
  author = {Stahlbauer, Andreas and Kreis, Marvin and Fraser, Gordon},
  title = {Testing Scratch Programs Automatically},
  year = {2019},
  isbn = {9781450355728},
  publisher = {Association for Computing Machinery},
  address = {New York, NY, USA},
  url = {https://doi.org/10.1145/3338906.3338910},
  doi = {10.1145/3338906.3338910},
  booktitle = {Proceedings of the 2019 27th ACM Joint Meeting on European Software Engineering Conference and Symposium on the Foundations of Software Engineering},
  pages = {165–175},
  numpages = {11},
  keywords = {Scratch, Automated Testing, Education, Property-based Testing},
  location = {Tallinn, Estonia},
  series = {ESEC/FSE 2019},
  note = "[Accessed 2020-04-21]"
}

@online{Resnick09,
  author = {Resnick, Mitchel and Maloney, John and Monroy-Hern\'{a}ndez, Andr\'{e}s and Rusk, Natalie and Eastmond, Evelyn and Brennan, Karen and Millner, Amon and Rosenbaum, Eric and Silver, Jay and Silverman, Brian and Kafai, Yasmin},
  title = {Scratch: Programming for All},
  year = {2009},
  issue_date = {November 2009},
  publisher = {Association for Computing Machinery},
  address = {New York, NY, USA},
  volume = {52},
  number = {11},
  issn = {0001-0782},
  url = {https://doi.org/10.1145/1592761.1592779},
  doi = {10.1145/1592761.1592779},
  journal = {Commun. ACM},
  month = nov,
  pages = {60–67},
  numpages = {8},
  note = "[Accessed 2020-04-21]"
}

@inproceedings{Maloney04,
  author={J. {Maloney} and L. {Burd} and Y. {Kafai} and N. {Rusk} and B. {Silverman} and M. {Resnick}},
  booktitle={Proceedings. Second International Conference on Creating, Connecting and Collaborating through Computing, 2004.},
  title={Scratch: a sneak preview [education]},
  year={2004},
  volume={},
  number={},
  pages={104-109},
  note = "[Accessed 2020-04-21]"
}

@article{Agrawal19,
  title = "Fault Coverage Based Test Suite Optimization Method for Regression Testing: Learning from Mistakes Based Approach",
  keywords = "Regression testing, Software maintenance, Heuristics, Greedy, Additional greedy, HGS, Enhanced HGS",
  author = "Agrawal, {Arun Prakash} and Ankur Choudhary and Arvinder Kaur and Hari Pandey",
  year = "2019",
  month = feb,
  day = "27",
  doi = "10.1007/s00521-019-04098-9",
  language = "English",
  journal = "Neural Computing and Applications",
  issn = "0941-0643",
  publisher = "springer",
  note = "[Accessed 2020-04-21]"
}

@inproceedings{Vahabzadeh18,
  author = {Vahabzadeh, Arash and Stocco, Andrea and Mesbah, Ali},
  title = {Fine-Grained Test Minimization},
  year = {2018},
  isbn = {9781450356381},
  publisher = {Association for Computing Machinery},
  address = {New York, NY, USA},
  url = {https://doi.org/10.1145/3180155.3180203},
  doi = {10.1145/3180155.3180203},
  booktitle = {Proceedings of the 40th International Conference on Software Engineering},
  pages = {210–221},
  numpages = {12},
  keywords = {test redundancy, test minimization, test model, test reduction},
  location = {Gothenburg, Sweden},
  series = {ICSE ’18},
  note = "[Accessed 2020-04-21]"
}

@inproceedings{Rothermel98,
  author = {Rothermel, Gregg and Harrold, Mary Jean and Ostrin, Jeffery and Hong, Christie},
  title = {An Empirical Study of the Effects of Minimization on the Fault Detection Capabilities of Test Suites},
  year = {1998},
  isbn = {0818687797},
  publisher = {IEEE Computer Society},
  address = {USA},
  booktitle = {Proceedings of the International Conference on Software Maintenance},
  pages = {34},
  numpages = {1},
  series = {ICSM ’98},
  note = "[Accessed 2020-04-21]"
}

